- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# aws_eks_cluster – Manage Elastic Kubernetes Service Clusters

New in version 2.7.

- Synopsis
- Requirements
- Parameters
- Notes
- Examples
- Return Values
- Status

## Synopsis

- Manage Elastic Kubernetes Service Clusters

## Requirements

The below requirements are needed on the host that executes this module.

- boto
- boto3
- botocore
- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
name - / required |  | Name of EKS cluster
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
role_arn - |  | ARN of IAM role used by the EKS cluster
security_groups - |  | list of security group names or IDs
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
state - | Choices: absent present ← | desired state of the EKS cluster
subnets - |  | list of subnet IDs for the Kubernetes cluster
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.
version - |  | Kubernetes version - defaults to latest
wait boolean | Choices: no ← yes | Specifies whether the module waits until the cluster is active or deleted before moving on. It takes "usually less than 10 minutes" per AWS documentation.
wait_timeout - | Default: 1200 | The duration in seconds to wait for the cluster to become active. Defaults to 1200 seconds (20 minutes).

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`
- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html
- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    # Note: These examples do not set authentication details, see the AWS Guide for details.

    - name: Create an EKS cluster
      aws_eks_cluster:
        name: my_cluster
        version: v1.10.0
        role_arn: my_eks_role
        subnets:
          - subnet-aaaa1111
        security_groups:
          - my_eks_sg
          - sg-abcd1234
      register: caller_facts

    - name: Remove an EKS cluster
      aws_eks_cluster:
        name: my_cluster
        wait: yes
        state: absent

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
arn string | when state is present | ARN of the EKS cluster Sample: arn:aws:eks:us-west-2:111111111111:cluster/my-eks-cluster
certificate_authority complex | after creation | Dictionary containing Certificate Authority Data for cluster
| data string | when the cluster has been created and is active | Base-64 encoded Certificate Authority Data for cluster
created_at string | when state is present | Cluster creation date and time Sample: 2018-06-06T11:56:56.242000+00:00
endpoint string | when the cluster has been created and is active | Kubernetes API server endpoint Sample: https://API_SERVER_ENDPOINT.yl4.us-west-2.eks.amazonaws.com
name string | when state is present | EKS cluster name Sample: my-eks-cluster
resources_vpc_config complex | when state is present | VPC configuration of the cluster
| security_group_ids list | always | List of security group IDs Sample: ['sg-abcd1234', 'sg-aaaa1111']
| subnet_ids list | always | List of subnet IDs Sample: ['subnet-abcdef12', 'subnet-345678ab', 'subnet-cdef1234']
| vpc_id string | always | VPC id Sample: vpc-a1b2c3d4
role_arn string | when state is present | ARN of the IAM role used by the cluster Sample: arn:aws:iam::111111111111:role/aws_eks_cluster_role
status string | when state is present | status of the EKS cluster Sample: ['CREATING', 'ACTIVE']
version string | when state is present | Kubernetes version of the cluster Sample: 1.10

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Will Thames (@willthames)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.